Emese Revfy | 6b90bd4 | 2016-05-24 00:09:38 +0200 | [diff] [blame] | 1 | ifdef CONFIG_GCC_PLUGINS |
| 2 | __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC)) |
| 3 | PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)") |
| 4 | |
Emese Revfy | 543c37c | 2016-05-24 00:11:37 +0200 | [diff] [blame] | 5 | SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so |
| 6 | |
Emese Revfy | 0dae776 | 2016-05-24 00:10:35 +0200 | [diff] [blame] | 7 | gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY) += cyc_complexity_plugin.so |
Emese Revfy | 543c37c | 2016-05-24 00:11:37 +0200 | [diff] [blame] | 8 | |
Emese Revfy | 38addce | 2016-06-20 20:41:19 +0200 | [diff] [blame] | 9 | gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += latent_entropy_plugin.so |
| 10 | gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += -DLATENT_ENTROPY_PLUGIN |
| 11 | ifdef CONFIG_PAX_LATENT_ENTROPY |
| 12 | DISABLE_LATENT_ENTROPY_PLUGIN += -fplugin-arg-latent_entropy_plugin-disable |
| 13 | endif |
| 14 | |
Emese Revfy | 543c37c | 2016-05-24 00:11:37 +0200 | [diff] [blame] | 15 | ifdef CONFIG_GCC_PLUGIN_SANCOV |
| 16 | ifeq ($(CFLAGS_KCOV),) |
| 17 | # It is needed because of the gcc-plugin.sh and gcc version checks. |
| 18 | gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV) += sancov_plugin.so |
| 19 | |
| 20 | ifneq ($(PLUGINCC),) |
| 21 | CFLAGS_KCOV := $(SANCOV_PLUGIN) |
| 22 | else |
| 23 | $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler) |
| 24 | endif |
| 25 | endif |
| 26 | endif |
| 27 | |
Emese Revfy | 65d59ec | 2016-06-20 20:40:24 +0200 | [diff] [blame] | 28 | GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y)) |
Emese Revfy | 6b90bd4 | 2016-05-24 00:09:38 +0200 | [diff] [blame] | 29 | |
Emese Revfy | 38addce | 2016-06-20 20:41:19 +0200 | [diff] [blame] | 30 | export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR |
| 31 | export SANCOV_PLUGIN DISABLE_LATENT_ENTROPY_PLUGIN |
Emese Revfy | 6b90bd4 | 2016-05-24 00:09:38 +0200 | [diff] [blame] | 32 | |
Kees Cook | ed58c0e | 2016-06-17 23:11:12 -0700 | [diff] [blame] | 33 | ifneq ($(PLUGINCC),) |
Emese Revfy | 543c37c | 2016-05-24 00:11:37 +0200 | [diff] [blame] | 34 | # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication. |
| 35 | GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS)) |
Emese Revfy | 6b90bd4 | 2016-05-24 00:09:38 +0200 | [diff] [blame] | 36 | endif |
| 37 | |
| 38 | KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS) |
| 39 | GCC_PLUGIN := $(gcc-plugin-y) |
Emese Revfy | caefd8c | 2016-06-26 17:38:20 +0200 | [diff] [blame] | 40 | GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y) |
Emese Revfy | 6b90bd4 | 2016-05-24 00:09:38 +0200 | [diff] [blame] | 41 | endif |
Kees Cook | ed58c0e | 2016-06-17 23:11:12 -0700 | [diff] [blame] | 42 | |
| 43 | # If plugins aren't supported, abort the build before hard-to-read compiler |
| 44 | # errors start getting spewed by the main build. |
| 45 | PHONY += gcc-plugins-check |
| 46 | gcc-plugins-check: FORCE |
| 47 | ifdef CONFIG_GCC_PLUGINS |
| 48 | ifeq ($(PLUGINCC),) |
| 49 | ifneq ($(GCC_PLUGINS_CFLAGS),) |
| 50 | ifeq ($(call cc-ifversion, -ge, 0405, y), y) |
| 51 | $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true |
| 52 | @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1 |
| 53 | else |
| 54 | @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1 |
| 55 | endif |
| 56 | endif |
| 57 | endif |
| 58 | endif |
| 59 | @: |
| 60 | |
| 61 | # Actually do the build, if requested. |
| 62 | PHONY += gcc-plugins |
| 63 | gcc-plugins: scripts_basic gcc-plugins-check |
| 64 | ifdef CONFIG_GCC_PLUGINS |
| 65 | $(Q)$(MAKE) $(build)=scripts/gcc-plugins |
| 66 | endif |
| 67 | @: |